/*
 * Player character
 */
 
 #ifndef PLAYERCHARACTER_INCLUDED
        #define PLAYERCHARACTER_INCLUDED

#include "gamecharacter.h"

class PlayerCharacter : public GameCharacter {
	public:
		enum Weapon { Fist, Skullshooter };
	protected:
		virtual void runController();
		Vect3d targetLocation;
		enum PlayerState { Stopped, Walking, AttackStart, AttackRecover };
		// Time left before we can enter our next state;
		int nextStateTime;
		PlayerState currentState;
		PlayerState nextState;
		virtual void hitWall(int blockx, int blocky);
		Component previousHitPoints;
		Component painLevel;
		int ammo;
		Weapon currentWeapon;
		
	public:
		PlayerCharacter(Manager *m);
		virtual ~PlayerCharacter();
		void setTarget(const Vect3d &target);
		void beginAttack(const Vect3d &target);
		Component getPainLevel() { return painLevel; }
		int getAmmo() { return ammo; }
		void addAmmo(int amount) { ammo += amount; }
		virtual void handleCollision(const Vect3d &amount, GameObject *what);
		void selectWeapon(Weapon w) { currentWeapon = w; }
		Weapon getWeapon() { return currentWeapon; }
		virtual void setKilled();
		void addHealth(Component amount) {
			hitPoints += amount;
			if (hitPoints > 100) 
				hitPoints = 100;
		}
	private:
		void doAttack();
};

#endif  // PLAYERCHARACTER_INCLUDED
