/*
 * Timing.h - handles platform specific timers.
 */

#ifdef	WIN32
	#include <allegro.h>
	#include <winalleg.h>
	extern LARGE_INTEGER timing_start_time;
	extern LARGE_INTEGER timing_frequency;
#else
	#include <sys/time.h>
	#include <time.h>
	extern struct timeval timing_start_time;
#endif
/*
 * Gives the number of milliseconds since the program started.
 */
unsigned int inline GetMilliseconds()
{

#ifdef WIN32
	LARGE_INTEGER now;
	QueryPerformanceCounter(&now);
	long long nowTicks = now.QuadPart;
	long long elapsedTicks = (nowTicks - timing_start_time.QuadPart);
	return (elapsedTicks / (timing_frequency.QuadPart / 1000));
#else
	struct timeval now;
	gettimeofday(& now, 0);
	unsigned int secs = now.tv_sec - timing_start_time.tv_sec;
	int usecs = now.tv_usec - timing_start_time.tv_usec;
	return (secs * 1000) + (usecs / 1000);
#endif
}

void InitMilliseconds();

